; Assembly Source File
; Created 21/06/2003, 13:36:27

; Ceci est le dbut du code source de mon programme tutorial.
; comme son nom l'indique, c'est un programme qui sert d'exemple de programmation.
; il a pour but d'expliquer comment coder un type particulier de programmes, les TSR.
; pour plus d'informations, il _faut_ lire le fichier  tutorial (mais comme vous tes srieux, vous l'avez videmment dj lu ;))
; programmer des TSR requiert de dj savoir programmer en assembleur 68000


;dans ce fichier on va regrouper tout le code d'installation du TSR
;c'est le code qui sera excut uniquement quand on tapera tutorial() dans la ligne de commande
;par habitude, j'ai 3 registres qui sont constants dans mes TSR
; a6 qui pointe vers la zone de donnes utilise par le programme
; a5 qui pointe vers la JumpTable et qui sert aux ROM_CALL. Pour info, la JumpTable est la liste des adresses des routines de l'AMS qu'on peut utiliser (les ROM_CALL)
; a4 qui pointe vers l'Event (vnement) en cours de traitement par le TSR

;les fichiers init_tsr.h, my_tsr.h et strings.h contiennent le code effectif du TSR qui sera recopi en RAM  l'installation


	include "os.h"
	include "event_id.h"
	xdef	_ti92plus
	xdef	_ti89
	xdef	_nostub
;une petite macro qui servira  faire les appels aux ROM_CALL
CALL macro
 move.l \1*4(a5),a0
 jsr (a0)
 endm


;premire partie du code : le code d'installation du TSR en mmoire
 movem.l d3-d7/a2-a6,-(a7)		;il faut bien sauvegarder un peu les registres ...
 move.l  200,a5				;on initialise un registre qui servira  faire les ROM_CALL

;premire chose  faire, vrifier qu'on est pas sur une Hardware 3 (TI-89 Titanium) vu qu'on ne sais pas encore comment elle va ragir (elle n'est pas sortie  la date o j'cris ce texte)
 move.l  a5,d0
 swap    d0
 andi.w  #$E0,d0
 cmp.w   #$80,d0
 beq     tsr_hardware_error

; ICI on peut placer le code pour initialiser le TSR
; en gnral, c'est  cet endroit que j'enregistre les TaskID des applications flash concernes par mes TSR
; pour l'exemple, on va regarder si notre TSR n'est pas dj install 
 lea     nom_du_tsr(pc),a0
 bsr     is_present
 tst.w   d0
 bne     tsr_deja_installe


;On reprend l'installation
;d'abord sauvegarder l'adresse du hook actuel
 move.l  4*EV_hook(a5),a4			;l'adresse o est stocke l'adresse du Hook actuel (=0 s'il n'y a pas de Hook, mais qu'il y en ait ou pas n'a pas d'importance)
 lea     old_event(pc),a0			;l'adresse o on va enregistrer l'adresse du Hook actuel pour pouvoir l'appeler
 move.l  (a4),(a0)

;allocation du bloc de mmoire o on va placer notre TSR
 move.l  #END_OF_HOOK-BEGINNING_OF_HOOK,d3	;c'est pour calculer la taille du TSR. On alloue un bloc de la mme taille dans la mmoire et on recopie notre TSR dedans
 move.l  d3,-(a7)
 CALL HeapAllocHigh				;on alloue un handle (i.e. un bloc de mmoire) tout en le verrouillant
 addq.l  #4,a7
 tst.w   d0
 beq     tsr_memory_error			;il n'y a pas assez de mmoire, c'est dommage :(

 lea     task_id(pc),a0
 move.w  d0,(a0)				;le numro du bloc sera aussi l'ID de notre TSR. Ca peut tre utile de le conserver (mais pas indispensable)

 move.w  d0,-(a7)
 CALL HeapDeref
 addq.l  #2,a7
 
 move.l  a0,(a4)				;on place l'adresse de notre nouveau Hook  l'endroit qu'il faut pour qu'il soit appel
 add.l   #$40010,(a4)				;a c'est des histoires de ghost space...

;copie du TSR dans le bloc en mmoire
 subq.l  #1,d3
 lea     BEGINNING_OF_HOOK(pc),a1
\loop:
 move.b  (a1)+,(a0)+
 dbra    d3,\loop
;l'installation du TSR est termine

;maintenant, on peut faire tout plein de trucs pour parfaire l'installation
;par exemple on peut demander  Comb d'enregistrer les touches utilises par ce TSR pour son aide commune
 pea     tsr_success_str(pc);autant afficher un petit message de succs, a ne fait pas de mal
tsr_disp_msg:
 CALL ST_showHelp
 addq.l  #4,a7
 movem.l (a7)+,d3-d7/a2-a6
 rts
tsr_deja_installe:
 pea     tsr_deja_installe_str(pc)
 bra     tsr_disp_msg
tsr_memory_error:
 pea     tsr_memory_error_str(pc)
 bra     tsr_disp_msg
tsr_hardware_error:
 pea     tsr_hardware_error_str(pc)
 bra     tsr_disp_msg
tsr_success_str:
 dc.b    'Tutorial Install',0
tsr_memory_error_str:
 dc.b    'Pas assez de mmoire libre',0
tsr_hardware_error_str:
 dc.b    'Calculatrice "insupportable" ;)',0 
tsr_deja_installe_str:
 dc.b    'Tutorial dj install !',0
 even


;il ne faudrait pas oublier d'inclure le fichier avec le code de notre TSR :)
  include "init_tsr.h"

is_present:
;<- a0.l pointeur vers le nom du TSR
;-> d0=TSR_ID du TSR s'il est prsent, =0 sinon
; dtruit a0-a1/d1-d2
 lea     -12(a7),a7
 move.l  a0,8(a7)
 clr.w   2(a7)
 move.w  #CM_EVHK_IS_PRESENT,(a7)
 move.l  a7,a0
 move.l  a0,-(a7)
 move.l  2700(a5),a0;EV_hook
 move.l  (a0),a0
 move.l  a0,d0
 beq     is_present_end
 jsr     (a0)					;on envoie l'Event directement aux TSR s'il y en a, on ne passe pas par EV_SendEvent !
 move.w  6(a7),d0
is_present_end:
 lea     16(a7),a7
 rts


